DAT fileName byte "RobotComAlpha03", 0
CON ' EEPROM Use
{


  $FF00  |                   |                   |                   |                   |
  $FF10  |                   |                   |                   |                   |
  $FF20  |                   |                   |                   |                   |
  $FF30  |                   |                   |                   |                   |
  $FF40  |                   |                   |                   |                   |
  $FF50  |                   |                   |                   |                   |
  $FF60  |                   |                   |                   |                   |
  $FF70  |                   |                   |                   |                   |
  $FF80  |                   |                   |                   |                   |
  $FF90  |                   |                   |                   |                   |
  $FF00  |                   |                   |                   |                   |
  $FFA0  |                   |                   |                   |                   |
  $FFC0  |        6          |        6          |        5          |        5          |
  $FFD0  |        4          |        4          |        3          |        3          |
  $FFE0  | Unit #2 firmware  |subV2, code2, X, X | Unit #1 firmware  |subV1, code1, X, X |
  $FFF0  | _FirmwareVersion  |_FirmwareSubVersion|                   |     Unit ID       |
  
  The basestation will have the firmware version of each other unit in it's EEPROM.
  Unit #N's fw location = _FirmwareLocation - (N * _FirmwareDiscriptionSize)

  Each Propeller with an permanently attached EEPROM (with 64K or more space)
  should have a unique ID.

  ID numbers 1 through 7 are QuickStart boards
  A label with the Propeller's ID number should be attached to the board when the ID
  number is assigned.
  
  Some Propeller IDs

  
}
  _FirmwareDiscriptionSize = 8 ' 4 for date, 1 for subV letter, 3 for other codes
                               ' codes include fw update started or successfully finished
  _FirmwareVersion = 110808  ' 4 bytes
  _FirmwareSubVersion = "8"  ' 1 byte, for now the following three bytes
  _FirmwareLocation = $FFF0
  _FirmwareSubLocation = _FirmwareLocation + 4 ' three last bytes aren't used yet
  _IdEepromLocation = $FFFC '_FirmwareLocation + 12 ' 4 bytes
  ' Unique to each Propeller
  
  _SystemIdEepromLocation = $FFF8 '_FirmwareLocation + 12 ' 4 bytes
  ' Used in multi Propeller systems.
  
  _FirstProtectedEeprom = _FirmwareLocation
  _EndOfProtectedEeprom = _FirmwareLocation + 16
  _FirmwareScratchPadLocation = $8000 ' use for wireless firmware updates

  
  ' EEPROM firmware update codes
  #0, _NoInfoYetFw, _UpdateStartedFw, _UpdateComplete ' Firmware updates will first be copied
                                                      ' to uppper EEPROM then from upper EEPROM
                                                      ' to lower EEPROM.
CON    '' Color enumeration added 120101 
  #0, _Black, _EasterEgg, _Blue1, _Blue2, _Blue, _Green1, _BlueGreen1, _Greenish1Blue2, _Greenish1Blue, { 0-8
    } _Green2, _Blueish1Green2, _Greenish2Blue2, _Greenish2Blue, _Green, _Blueish1Green, _Blueish2Green, { 9-15
    }_White, _Red, _Yellow{, _Green}, _Purple, _Cyan, _FRed, _FGreen, _YellowOrange, _Orange, { 16-24
  '  } _FirstTempColor
  
  '' Parameter enumeration
  #0, _PCol, _PRow, _PColorText, _PColorBackground, _PActionHigh, _PActionLow, _PString
  
  '' Menu Actions
  #0, _NoAction, _SetTimer, _SetAlarm, _LightSingle, _LightGroup, _MainDutyChange, _PerimeterDutyChange, { 0-6
    } _LedBack, _LedForward, _OneUpMenu, _ChannelUp, _ChannelDown, _VolumeUp, _VolumeDown, _BoxPower, {  7-14
    } _VcrPower, _TvPower, _SetTarget, _OvenTime, _MenuSEdit, _MenuSView, _ActiveHour, _ActiveMinute, {  15-22
    } _ActiveSecond, _ActiveYear, _ActiveMonth, _ActiveDate, _ActiveDayOfWeek, _LineOn1, _LineOn2, { 23-29
    } _LineOn3, _LineOn4, _LineOn5, _NunchuckOff, _ToggleSdAction { 30-34 }
       
CON
  ' RobotComAlpha03 add 8-bit data bus and TouchscreenSlave info
  ' 03 Big change 

  ' 8-bit single Prop to single Prop message enumeration 
  '#1, _NewToScreen, _OldToScreen, _TouchFromScreen

  ' 8-bit bus message enumeration 
  #1, _MasterSync, _RequestSync, _BusMessage, _NewMenu{clear screen}, _DisplayText, _PlotPixels,{not used yet
    } _TouchFromScreen
  
  
  ' offsets, 8-bit bus only two Props, master and slave combo. 
  '_TxType8Bit = 0  ' one of 8-bit bus messages
  _LineXOffset8BitPr = 0
  _LineYOffset8BitPr = 1
  _TextColorOffset8BitPr = 2
  _BackgroundColorOffset8BitPr = 3
  _TextOffset8BitPr = 4


  ' PlayStation2 Remote Constants
  _Cs8BitPrPin = 15
  _Clock8BitPrPin = 14

  _PrMaxSystemId = 1
  
  ' control character enumeration
  #0, _Null, _StartOfHeader, _StartText
  _CarriageReturn = 13
  _GroupSeparator = 29
  
  ' com type enumeration
  #1, _DirectSinglePacketWireless, _HoppingSinglePacketWireless, {
    } _DirectAsciiWireless, _HoppingAsciiWireless, {
    } _DirectSinglePacket, _HoppingSinglePacket, _DirectAscii, {
    } _HoppingAscii, _EightBit {Probably not needed since an 8-bit line
    will know it's an 8-bit line.} 
  ' both _DirectAsciiWireless, _HoppingAsciiWireless messages
  ' should only transmit a byte with the value of 13 as an end of message
  ' character.  Data should be sent as ASCII hexidecimal to avoid sending
  ' a 13 other than at the end of a message.
  ' I use a serial driver that watches for an end of message character so
  ' I don't want the end of message character showing up other than at the
  ' end of a message.  These two com types are likely used with XBee modules.

  ' I have yet to come up with a "hopping" protocol.
  
  ' targets (for now I think I have fewer than 254)
  ' robot targets
  _Broadcast = 255
  #1, _Reserved1, _Scribbler2, _Roomba, _Roboni, _Roboni2, _Omni, _Rover5, { 1 - 6
    } _Treaded, _Arm, _TRex600, _QuadCopterLarge, _QuadCopterSmall ' 7 - 11
  ' controller targets  
  #20, _UniverseRemoteInput, _UniverseRemoteGraphics, _Ps2TouchscreenRemoteInput, { 20 - 22
    }  _Ps2TouchscreenRemoteGraphics, _RcAssist, _WiiCameraGuidance ' 23 - 25
  ' lab targets   
  #40, _LabA, _LabB, _LabC, _LabD, _LabE, _LabF, _LabG, _LabH ' 40 - 47
  ' QuickStart targets
  #59, _GenericQuickStart, _QuickStart00, _QuickStart01, _QuickStart02, { 59 - 62
    } _QuickStart03, _QuickStart04, _QuickStart05, _QuickStart06, { 63 - 66
    } _QuickStart07, _QuickStart08, _QuickStart09, _QuickStart10, { 67 - 70
    } _QuickStart11 ' 71
  ' FOB targets
  #79, _GenericFob, _Fob0, _Fob1, _Fob2, _Fob3, _Fob4, _Fob5, _Fob6, _Fob7, { 79 - 87
    } _Fob8, _Fob9, _ModifiedFob ' 88 - 90

  ' transmitter type
  #1, _NordicOld, _NordicNew, _NordicFob, _Spektrum, _Rc, _XBeeZb, XBeeZbPro, { 1 - 7
    } _XBeeXsc ' 8
    
  ' transmission type
  #1, _ControllerStream, _DataOutNoReply, _DataExpectReply, _Command, _Enquire, _Acknowledgment

  ' _Command enumeration (should be preceded by "_Command")
  #0, _StopCmd, _PlayStation2Cmd, _WiiNunchuckCmd, _ButtonKnobAndKeyCmd, {
    } _ButtonKnobKeyAndNunchuckCmd, _QsPadsCmd, _QsTerminalCmd, _FobCmd, _FobModifiedCmd 
  {
  ' _Command types
  _DirectionVectorFloat = _ButtonKnobAndKey
  _AdjustPid = _Button
  _PidData = _ButtonAndKnob ' followed by three PID parameters coded in ASCII Hex.
  _DisplayMessage = _LedSingle ' followed by the single byte message code
  _DisplayLedText = _LedGroup ' followed by text to display
  _ChangeLedSettings = _StopTxNunchuckToRoboni0 ' followed by single byte setting code

  ' LED settings enumeration (after  _Command, _ChangeLedSettings)
  #0, _DelayUp, _DelayDown, _BrightnessUp, _BrightnessDown

  ' LED messages enumeration (after  _Command, _DisplayMessage)
  #0, _LedMessageR1, _LedMessageL1, _LedMessageR2, _LedMessageL2, { 0 - 3
    } _LedMessageP, _LedMessagePUp, _LedMessagePDown, { 4 - 6
    } _LedMessageI, _LedMessageIUp, _LedMessageIDown, { 7 - 9
    } _LedMessageD, _LedMessageDUp, _LedMessageDDown, { 10 - 12
    } _LedMessageCR, _LedMessageAllFont, _LedMessagePattern

    }
  ' controller enumeration (should be preceded by "_ControllerStream")
  #0, _NoController, _PlayStation2, _WiiNunchuck, _UniButtonKnobAndKey, {
    } _UniButtonKnobKeyAndNunchuck, _QsPads, _QsTerminal, _Fob, _FobModified 

  ' Scribbler2 _DataOut data types probably send eight words per packet
  #0, _FileNameData, _Result1Data, _Result2Data, _Result3Data, _MotionData

  ' offsets
  _TargetOffset = 1
  _AttachedOffset = 2
  _MessageCountOffset = 3
  _TransmissionTypeOffset = 4
  _TransmissionSubTypeOffset = 5
  
  ' _DefaultData from _Scribbler2 offsets
  _BatteryS2 = 7 ' one byte, two hexadecimal characters.
  _LeftSpeedS2 = 9 ' two bytes, four hexadecimal characters.
                 ' instead of -256 to 256, use 0 to 511, (add and subtract 255, which loses -256)
  _RightSpeedS2 = 17 ' two bytes, four hexadecimal characters.

  ' _FileNameData from _Scribbler2 offset
  _FileNameS2 = 7

  ' _LightSensorData from _Scribbler2 offset
  _LeftLightSensorS2 = 7 ' one byte, two hexadecimal characters.
  _MiddleLightSensorS2 = 9
  _RightLightSensorS2 = 11
  _LeftObstacleSensorS2 = 13 ' one bit, one ASCII binary character.
  _RightObstacleSensorS2 = 14
  _LeftLineSensorS2 = 15 ' one bit, one ASCII binary character.
  _RightLineSensorS2 = 16

  ' _QsPads offset
  _Pad0Qs = _TransmissionSubTypeOffset + 1 ' one byte, two hexadecimal characters.
  
  ' QuickStart pads as remote enumeration
  #0, _StarRevHard, _StarRev, _StarForward, _StartForwardHard, {
    } _PortForwardHard, _PortForward, _PortRev, _PortRevHard

  _S2Baud = 57600
  _PrBaud = 57600
  _S2NordicPayloadSize = 24
  _LargeBufferSize = 512
  _LargestStructureSize = 32
  
  ' PlayStation 2 Remote (Prd)data type enumeration
  #0, _DatePrd, _TimePrd, _StatusPrd, _SpeedPrd, _CoursePrd, _BatteryPrd, { 0 - 6
    } _XTouchPrd, _YTouchPrd, _SdTogglePrd, _OtherMessagePrd, { 7 - 10
    } _SdUseGrantedPrd, _SdDeniedPrd ' 11 - 12
  _Skip13EolPrd = 13
  #14, _LastPrd
  
  ' _Enquire types (after transmission type), Also use in CheckStylusDown method as modes
  #0, _Button, _ButtonAndKnob, _ButtonKnobAndKey, _ButtonKnobKeyAndNunchuck ' 0 - 3
      
  ' PlayStation 2 Remote (Pr) constants
  _LargestParameterSentExtraPr = 11 
  _LargestParameterSentNormalPr = 9
  _LargestDynamicParameter = _LargestParameterSentExtraPr
  _DataSizeSmallPr = 3
  _DataSizeDatePr = 11
  _DataSizeModePr = 24
  _DataSizeTouchXyPr = 3       ' includes room for terminating zero 
  _DataSizeSdStatePr = 14
  
  _DebugTxPin = 30 
  _DebugRxPin = 31

  '' Mode enumeration
  #0, _CenteredMode, _LeftAligned, _RightAligned

  _ChangableParameterFlag = "\"  ' followed by GPS data type, followed by format info.
  _FrameChangableParameter = "/"
  
   ' changable parameter format enumeration
  #0, _LeftJustifyFormat, _CenterFormat, _RightJustifyFormat, _LeftWithOneSpaceFormat, _RightWithOneSpaceFormat

PUB FileNameMethod

  result := @fileName
  