DAT fileName byte "dwd_AssignId", 0
CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  _BufferSize = $10000 - Header#_FirmwareLocation ' 16
  _EndOfRam = $7FFF
  _EndOfEeprom = $FFFF
  _ByteHexDigits = 2
  _WordHexDigits = 4
  _LongHexDigits = 8
  _NumberOfHexades = 2 ' Hexades are hexadecimal decades
  _NumberOfColumns = _NumberOfHexades * $10  
  ' programState enumeration
  '#0, _RamOnly, _EepromAlso
  ' eepromType enumeration
  '#0, _Eeprom32K, _Eeprom64K
  
VAR

  long activeAddress
  'byte testdata[4]
  'byte buttonId
  byte buffer[_BufferSize]', buffer2[_BufferSize]
  byte lastLowByte, lastHighByte
  'byte programState, eepromType
  
OBJ

  Eeprom : "dwd_PropellerEeprom"
  Header : "RobotComAlpha03"
  Pst : "Parallax Serial Terminal"
  
PUB Main | localCharacter

  'buttonId := _IdToAssign
  
  Pst.Start(57600)
  waitcnt(clkfreq * 3 + cnt)
  
  Pst.str(String(13, "  fileName = "))
  Pst.str(@fileName)
  Pst.str(String(13, 13, " This program allows one to write an ID number to EEPROM")) 

  Pst.str(String(13, 13, " Making sure EEPROM is at least 64K."))
  'if programState == _RamOnly
  'Pst.str(String(13, " Reading from EEPROM address $"))
  Pst.str(@readFrom) 
  Pst.hex(_EndOfRam, _WordHexDigits)
  Eeprom.ToRam(@lastLowByte, @lastLowByte, _EndOfRam)
  Pst.str(String(13, " lastLowByte = $"))
  Pst.hex(lastLowByte, _ByteHexDigits)
  'Pst.str(String(13, " Reading from EEPROM address $"))
  Pst.str(@readFrom) 
  Pst.hex(_EndOfEeprom, _WordHexDigits)
  Eeprom.ToRam(@lastHighByte, @lastHighByte, _EndOfEeprom)
  Pst.str(String(13, " lastHighByte = $"))
  Pst.hex(lastHighByte, _ByteHexDigits)
  if lastLowByte == lastHighByte
    lastHighByte++
    Eeprom.FromRam(@lastHighByte, @lastHighByte, _EndOfEeprom)
    Eeprom.ToRam(@lastLowByte, @lastLowByte, _EndOfRam)
    Pst.str(String(13, " Writing "))
    Pst.dec(lastHighByte)
    Pst.str(String(" to EEPROM address $"))
    Pst.hex(_EndOfEeprom, _WordHexDigits)
    Eeprom.ToRam(@lastHighByte, @lastHighByte, _EndOfEeprom)
    'Pst.str(String(13, " Reading from EEPROM address $"))
    Pst.str(@readFrom)
    Pst.hex(_EndOfRam, _WordHexDigits)
    Eeprom.ToRam(@lastLowByte, @lastLowByte, _EndOfRam)
    Pst.str(String(13, " lastLowByte = $"))
    Pst.hex(lastLowByte, _ByteHexDigits)
    if lastLowByte == lastHighByte
      lastHighByte--
      Pst.str(String(13, " This EEPROM is only 32K."))
      Pst.str(String(13, " You will not be able to store data in"))
      Pst.str(String(13, " the upper section of EEPROM."))
      Pst.str(String(13, " Restoring original EEPROM value."))
      Eeprom.FromRam(@lastHighByte, @lastHighByte, _EndOfEeprom) 
      Pst.str(String(13, 13, " **** End of Program ****"))
      Pst.char(7) ' bell
      'epromType := _Eeprom32K
      repeat
    else
      lastHighByte--
      Pst.str(String(13, " This EEPROM is at least 64K."))
      'eepromType := _Eeprom64K
      Pst.str(String(13, " Restoring original EEPROM value."))
      Eeprom.FromRam(@lastHighByte, @lastHighByte, _EndOfEeprom) 
  
  activeAddress := Header#_FirmwareLocation  
  repeat
    if activeAddress > _EndOfEeprom - _BufferSize + 1 ' $FFF0
      activeAddress := _EndOfEeprom - _BufferSize + 1
      Pst.str(String(13, " Changing activeAddress."))
    Pst.str(String(13, " Reading "))
    Pst.dec(_BufferSize)
    Pst.str(String(" bytes from EEPROM address $"))
    Pst.hex(activeAddress, _WordHexDigits)
    'Pst.char(13)
    'Eeprom.ToRam(@buffer, @buffer + _BufferSize - 1, Header#_FirmwareLocation)
    \DumpEeprom(activeAddress, _BufferSize)
    Pst.str(String(13, " These are the EEPROM options:"))
    Pst.str(@menu)
    localCharacter := Pst.charIn
    case localCharacter
      "x", "X":
        Pst.str(String(13, 13, " **** End of Program ****"))
        repeat
      "g", "G":
        \GlobalId
      "s", "S":
        \SystemId
      "r", "R":
        \Read
      "f", "F":
        \Fill
      "l", "L":
        \LocationWrite
      
PUB GlobalId

  activeAddress := Header#_IdEepromLocation
  Pst.str(String(13, 13, " A global ID will be assigned at EEPROM location $"))   
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, " Please enter value of global ID."))
  'result := GetNumberHex(_LongHexDigits)
  result := BurnValue(activeAddress)
  Pst.str(String(13, " A global ID was successfully updated. Global ID = $"))   
  Pst.hex(result, _LongHexDigits)
  Pst.str(String(" (or "))
  Pst.dec(result)
  Pst.str(String(" in base 10).", 13))
  
  
PUB SystemId

  activeAddress := Header#_SystemIdEepromLocation
  Pst.str(String(13, 13, " A system ID will be assigned at EEPROM location $"))   
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, " Please enter value of system ID."))
  result := BurnValue(activeAddress)
  Pst.str(String(13, " A system ID was successfully updated to $"))   
  Pst.hex(result, _LongHexDigits)
  Pst.str(String(" (or "))
  Pst.dec(result)
  Pst.str(String(" in base 10).", 13))
  
  
PUB Read 

  Pst.str(String(13, 13, " Please enter the EEPROM location to read."))   
  activeAddress := GetNumberHex(_WordHexDigits)
  'Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, " Please enter the number of bytes to read from this location."))
  result := GetNumberHex(_WordHexDigits)
  Pst.str(String(13, " Reading the EEPROM from location $"))   
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(" to $"))   
  Pst.hex(activeAddress + result - 1, _WordHexDigits)
  Pst.char(13) 
  \DumpEeprom(activeAddress, result)
  
  
  
PUB Fill | localSize, localAddress, sizeCountDown

  Pst.str(String(13, 13, " Please enter the EEPROM location to fill."))   
  activeAddress := GetNumberHex(_WordHexDigits)
  'Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, " Please enter the number of bytes to fill at this location."))
  localSize := GetNumberHex(_WordHexDigits)
  if activeAddress + localSize - 1 > _EndOfEeprom
    Pst.str(String(13, "  There are not "))
    Pst.dec(localSize)
    Pst.str(String(" bytes to fill. Filling "))
    localSize := _EndOfEeprom - activeAddress + 1  
    Pst.dec(localSize)
    Pst.str(String("  bytes."))
    
  sizeCountDown := localSize   
  Pst.str(String(13, " Please enter byte value to store at these locations."))
  result := GetNumberHex(_ByteHexDigits)
  bytefill(@buffer, byte[@result], _BufferSize)
  localAddress := activeAddress
  repeat while sizeCountDown => _BufferSize
    Eeprom.FromRam(@buffer, @buffer + _BufferSize - 1, localAddress)
    localAddress += _BufferSize
    sizeCountDown -= _BufferSize
  if sizeCountDown > 0
    Eeprom.FromRam(@buffer, @buffer + sizeCountDown - 1, localAddress)
  Pst.str(String(13, " The EEPROM locations from $"))   
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(" to $"))   
  Pst.hex(activeAddress + localSize - 1, _WordHexDigits)
  Pst.str(String(13, " were filled with the value $"))
  Pst.hex(result, _ByteHexDigits)
  Pst.char(13) 
  \DumpEeprom(activeAddress, localSize)
  
PUB LocationWrite 

  Pst.str(String(13, 13, " Please enter the EEPROM location to update."))   
  activeAddress := GetNumberHex(_WordHexDigits)
  'Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, " Please enter value to store at this location."))
  result := BurnValue(activeAddress)
  Pst.str(String(13, " The EEPROM location $"))   
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(" was updated with the value $"))   
  Pst.hex(result, _LongHexDigits)
  Pst.str(String(" (or "))
  Pst.dec(result)
  Pst.str(String(" in base 10).", 13))
  Pst.str(String(13, " Displaying four bytes from this location.", 13)) 
  \DumpEeprom(activeAddress, _LongHexDigits)
  
PUB BurnValue(localPtr) | localSize, localTemp', byteCount

  'byteCount := 0
  localSize := localPtr // 4
  
  Pst.str(String(13, 13, " The EEPROM address $"))
  Pst.hex(localPtr, _WordHexDigits)
  if localSize == 0
    localSize := _LongHexDigits
    'result := _LongHexDigits 
    Pst.str(String(" is long alined."))     
  elseif localSize == 2
    localSize := _WordHexDigits
    'result := _WordHexDigits
    Pst.str(String(" is not long alined."))
    Pst.str(String(13, " It is word alined.")) 
  else
    
    localSize := _ByteHexDigits
    'result := localSize
    Pst.str(String(" is not long alined."))
    Pst.str(String(13, " It is byte alined.")) 
  'result := localSize
  Pst.str(String(13, " Please enter a hexadecimal value of up to "))
  Pst.dec(localSize)
  Pst.str(String("  digits to store to EEPROM"))
  localTemp := GetNumberHex(localSize)
  'localTemp := result
  Pst.str(String(13, 13, " The value $"))
  if localTemp > $FF
    'Pst.str(String(13, 13, " The value $"))
    if localTemp > $FFFF
      Pst.hex(localTemp, _LongHexDigits)
    else
      Pst.hex(localTemp, _WordHexDigits)
    Pst.str(String(" is too large to fit in one byte."))
    Pst.str(String(13, " The byte value $"))
    Pst.hex(byte[@localTemp], _ByteHexDigits)   
    Pst.str(String(" will be stored at EEPROM address $"))
    Pst.hex(localPtr, _WordHexDigits)
    'Eeprom.FromRam(@localTemp, @localTemp, localPtr)
    'localTemp <<= 8
    
    Pst.str(String(13, " The second byte with the value of $."))
    'Pst.str(String(13, " The value $"))
    Pst.hex(byte[@localTemp + 1], _ByteHexDigits)   
    Pst.str(String(" will be stored at EEPROM address $"))
    Pst.hex(localPtr + 1, _WordHexDigits)      
    'Eeprom.FromRam(@localTemp + 1, @localTemp + 1, localPtr + 1)
    if localTemp > $FFFF
      'localTemp <<= 8
      Pst.str(String(13, " The third byte with the value of $."))
      Pst.hex(byte[@localTemp + 2], _ByteHexDigits)   
      Pst.str(String(" will be stored at EEPROM address $"))
      Pst.hex(localPtr + 2, _WordHexDigits)
      'Eeprom.FromRam(@localTemp, @localTemp, localPtr + 2)
      'if localTemp > $FFFFFF
        'localTemp <<= 8
      Pst.str(String(13, " The fourth byte with the value of $."))
      Pst.hex(byte[@localTemp + 3], _ByteHexDigits)   
      Pst.str(String(" will be stored at EEPROM address $"))
      Pst.hex(localPtr + 3, _WordHexDigits)
      Eeprom.FromRam(@localTemp, @localTemp + 3, localPtr)
      'else
        'Eeprom.FromRam(@localTemp, @localTemp + 2, localPtr)
    else
      Eeprom.FromRam(@localTemp, @localTemp + 1, localPtr)     
  else 
    'Pst.str(String(13, 13, " The value $"))
    Pst.hex(localTemp, _ByteHexDigits)   
    Pst.str(String(" will be stored at EEPROM address $"))
    Pst.hex(localPtr, _WordHexDigits)
    Eeprom.FromRam(@localTemp, @localTemp, localPtr)

PUB GetNumberHex(countDown) | localCharacter, localCount

  localCount := countDown
  Pst.str(String(13, 13, " Enter "))
  Pst.dec(countDown)
  Pst.str(String(" digit hexadecimal value."))
  Pst.str(String(13, " Use characters 0-9 and A-F. Characters outside this range will be ignored.")) 
  Pst.str(String(13, " Use the ", 34, "Enter", 34, " key if entering fewer than "))
  Pst.dec(countDown)
  Pst.str(String(" digits."))
  Pst.str(String(13, " Press ", 34, "x", 34, " to return to the main menu without saving changes. "))  
  repeat 
    localCharacter := Pst.charIn
    if localCharacter == "x" or localCharacter == "X"
      Pst.str(String(13, " Return to the main menu. ", 13))
      activeAddress := Header#_FirmwareLocation
      abort -1
    elseif localCharacter => "0" and localCharacter =< "9"
      countDown--
      result *= $10
      result += localCharacter - "0" 
    elseif localCharacter => "a" and localCharacter =< "f"
      countDown--
      result *= $10
      result += localCharacter - "a" + $A   
    elseif localCharacter => "A" and localCharacter =< "F"
      countDown--
      result *= $10
      result += localCharacter - "A" + $A
  while countDown and localCharacter <> 13    
  Pst.str(String(13, 13, " You entered: $"))
  Pst.hex(result, localCount)

{PUB DumpBuffer(localPtr, localSize) | abortAddress

  abortAddress := localPtr + localSize
  result := localPtr // $10
  Pst.char(13)
  if result > 0  ' if not hexadecimal alined then diplay extra bytes first.  
    Pst.str(String(13, " Location $"))
    'Pst.char(32)
    'Pst.char("$")
    Pst.hex(localPtr, _WordHexDigits)
    Pst.char(":")
    repeat result
      Pst.char(32)
      Pst.char("$")
      Pst.hex(byte[localPtr++], _ByteHexDigits)
      if localPtr => abortAddress
        Pst.char(13)
        abort
  repeat
    Pst.str(String(13, " Location $"))
    Pst.hex(localPtr, _WordHexDigits)
    Pst.char(":") 
    repeat _NumberOfColumns
      Pst.char(32)
      Pst.char("$")
      Pst.hex(byte[localPtr++], _ByteHexDigits)   
      if localPtr => abortAddress
        Pst.char(13)
        abort
    Pst.char(13)
}
PUB DumpEeprom(localPtr, localSize) | abortAddress, hubLimit, hubIndex

  abortAddress := localPtr + localSize
  if abortAddress > _EndOfEeprom + 1
    abortAddress := _EndOfEeprom + 1
    Pst.str(String(13, "  There are not "))
    Pst.dec(localSize)
    Pst.str(String(" bytes to read. Reading "))
    localSize := _EndOfEeprom - localPtr + 1
    Pst.dec(localSize)
    Pst.str(String("  bytes."))  
  hubLimit := @buffer + _BufferSize ' do not write to this address or higher addresses
  hubIndex := @buffer
  {Pst.str(String(13, "  activeAddress = $"))
  Pst.hex(activeAddress, _WordHexDigits)
  Pst.str(String(13, "  localPtr = $"))
  Pst.hex(localPtr, _WordHexDigits)
  Pst.str(String(13, "  abortAddress = $"))
  Pst.hex(abortAddress, _LongHexDigits)
  Pst.str(String(13, "  hubIndex = $"))
  Pst.hex(hubIndex, _WordHexDigits)
  Pst.str(String(13, "  hubLimit = $"))
  Pst.hex(hubLimit, _WordHexDigits)}  
  result := localPtr // $10 ' so rows start with $XXX0
  {Pst.str(String(13, "  result = $"))
  Pst.hex(result, _WordHexDigits)
  Pst.str(String(" (or "))
  Pst.dec(result)
  Pst.str(String(" in base 10).", 13))  }
  Pst.char(13)
  if result > 0  ' if not hexadecimal alined then diplay extra bytes first.
    Eeprom.ToRam(@buffer, @buffer + result - 1, localPtr)
   
    Pst.str(String(13, "  EEPROM $"))
    'Pst.char(32)
    'Pst.char("$")
    Pst.hex(localPtr, _WordHexDigits)
    Pst.char(":")
    Eeprom.ToRam(@buffer, hubLimit - 1, localPtr)
    repeat result
      if hubIndex => hubLimit
        Pst.str(String(13, "  ******* This should not happen when _BufferSize is larger than 15."))
        hubIndex := @buffer
        Eeprom.ToRam(@buffer, hubLimit - 1, localPtr)
      Pst.char(32)
      Pst.char("$")
      Pst.hex(byte[hubIndex++], _ByteHexDigits)   
      if ++localPtr => abortAddress
        Pst.char(13)
        abort
    hubIndex := @buffer
  Eeprom.ToRam(@buffer, hubLimit - 1, localPtr)
  repeat
    Pst.str(String(13, " EEPROM $"))
    Pst.hex(localPtr, _WordHexDigits)
    Pst.char(":") 
    repeat _NumberOfColumns
      if hubIndex => hubLimit
        hubIndex := @buffer
        Eeprom.ToRam(@buffer, hubLimit - 1, localPtr)
        'Pst.char("T") ' To Ram
        'Pst.char("R") 
      Pst.char(32)
      Pst.char("$")
      Pst.hex(byte[hubIndex++], _ByteHexDigits)   
      if ++localPtr => abortAddress
        'Pst.str(String(13, "abort, localPtr = $"))
        'Pst.hex(localPtr, _LongHexDigits)
        Pst.char(13)
        abort
    Pst.char(13)

DAT

menu          byte 13, 13, " Enter a single character to select menu option."
              byte 13, " x) Exit Program"
              byte 13, " g) assign global ID (each Propeller should be different)"
              byte 13, " s) assign system ID"
              byte 13, " r) read a section of EEPROM"
              byte 13, " f) fill each byte in a section of EEPROM with a single value"
              byte 13, " l) change arbitrary address location", 13, 0

readFrom      byte 13, " Reading from EEPROM address $", 0                  